<?php
include_once "config.php";
$title = "Minimal Mail - Message";
include_once "header.php";

$debug = 0; // remove when this file is done

if ($_REQUEST[id]) { $_SESSION[id] = $_REQUEST[id]; }

if ($_REQUEST[mode]) { $_SESSION[mode] = $_REQUEST[mode]; }
if (! $_SESSION[mode]) { $_SESSION[mode] = "PLAIN"; }


// get all the raw headers for manual parsing later
$rawheaders = explode("\n", imap_fetchheader($mbox, $_SESSION[id]));
foreach ($rawheaders as $rawheader) {
  list($key, $value) = explode(":", $rawheader);
  if ($debug) { echo "DEBUG: key:value: ".strtolower($key).":".strtolower($value)."<br>\n"; }
  $headers[strtolower($key)] = strtolower($value);
}

// get a pretty list of the headers for easy display later
$header = imap_header($mbox, $_SESSION[id]);
if ($debug) {
  echo "DEBUG: from header:". print_r($header->from);
  echo "DEBUG: to header:". print_r($header->to);
  echo "DEBUG: header<br><pre>";
  print_r($header);
  echo "</pre>\n";
}

$struct = imap_fetchstructure($mbox, $_SESSION[id]);
$parts = create_part_array($struct);

foreach ($parts as $part) {
  // RAW body
  $body[RAW] = imap_body($mbox, $_SESSION[id]);
  if (substr_count($headers["content-transfer-encoding"], "base64") >= 1) { $body[RAW] = base64_decode($body[RAW]); } //base64
  //elseif (substr_count($headers["content-transfer-encoding"],  "utf-8") >= 1) { $body[RAW] = imap_utf8($body[RAW]); } //utf-8
  //elseif (substr_count($headers["content-transfer-encoding"],  "7bit") >= 1) { $body[RAW] = mb_convert_encoding($body[RAW], "ISO_8859-1", "UTF7-IMAP"); } //7bit
  elseif (substr_count($headers["content-transfer-encoding"],  "quoted-printable") >= 1) { $body[RAW] = quoted_printable_decode($body[RAW]); } //quotedprintable
  if (substr_count($headers["content-type"], "plain") >= 1) { $body[RAW] = "<pre>".$body[RAW]."</pre>\n"; } // text/plain
  elseif (substr_count($headers["content-type"], "html") >= 1) { } // text/html
  else { $body[RAW] = "<pre>".htmlentities($body[RAW])."</pre>\n"; } // text/plain
  $body[RAW] = ereg_replace("[[:alpha:]]+://[^<>[:space:]]+[[:alnum:]/]", "<a href=\"\\0\">\\0</a>", $body[RAW]); // detect urls
  // PLAIN body
  if ($part[part_object]->subtype == "PLAIN") {
    $body[PLAIN] = imap_fetchbody($mbox, $_SESSION[id], $part[part_number]);
    //if ($part[part_object]->encoding == 0) { $body[PLAIN] = mb_convert_encoding($body[PLAIN], "ISO_8859-1", "UTF7-IMAP"); } //7bit
    //elseif ($part[part_object]->encoding == 1) { $body[PLAIN] = imap_utf8($body[PLAIN]); } //8bit
    if ($part[part_object]->encoding == 2) { $body[PLAIN] = imap_binary($body[PLAIN]); } //binary
    elseif ($part[part_object]->encoding == 3) { $body[PLAIN] = base64_decode($body[PLAIN]); } //base64
    elseif ($part[part_object]->encoding == 4) { $body[PLAIN] = quoted_printable_decode($body[PLAIN]); } //quotedprintable
    $body[PLAIN] = "<pre>$body[PLAIN]</pre>";
    $body[PLAIN] = ereg_replace("[[:alpha:]]+://[^<>[:space:]]+[[:alnum:]/]", "<a href=\"\\0\">\\0</a>", $body[PLAIN]); // detect urls
  }
  // HTML body
  if ($part[part_object]->subtype == "HTML") {
    $body[HTML] = imap_fetchbody($mbox, $_SESSION[id], $part[part_number]);
    //if ($part[part_object]->encoding == 0) { $body[HTML] = mb_convert_encoding($body[HTML], "ISO_8859-1", "UTF7-IMAP"); } //7bit
    //elseif ($part[part_object]->encoding == 1) { $body[HTML] = imap_utf8($body[HTML]); } //8bit
    if ($part[part_object]->encoding == 2) { $body[HTML] = imap_binary($body[HTML]); } //binary
    elseif ($part[part_object]->encoding == 3) { $body[HTML] = base64_decode($body[HTML]); } //base64
    elseif ($part[part_object]->encoding == 4) { $body[HTML] = quoted_printable_decode($body[HTML]); } //quotedprintable
  }
}

// display top menu
echo "<a href=\"messagelist.php\"><b>Back</b></a><br>\n";

if ($error) { echo $error; }

echo "<b>Actions:</b> \n";
$tourl = urlencode($header->from[0]->mailbox . "@" . $header->from[0]->host);
echo "<a href=\"compose.php?to=$tourl \">Reply</a>&nbsp;&nbsp; \n";
echo "<a href=\"deletecheck.php?id=$_SESSION[id]\">Delete</a>&nbsp;&nbsp; \n";
echo "<br>\n";
echo "<br>\n";

echo "<b>Mode:</b> \n";
if (($_SESSION[mode] != "PLAIN") && ($body[PLAIN])) { echo "<a href=\"message.php?mode=PLAIN\">Plain</a>&nbsp;&nbsp; "; } else { echo "Plain&nbsp;&nbsp; "; }
if (($_SESSION[mode] != "HTML") && ($body[HTML])) { echo "<a href=\"message.php?mode=HTML\">HTML</a>&nbsp;&nbsp; "; } else { echo "HTML&nbsp;&nbsp; "; }
if (($_SESSION[mode] != "RAW") && ($body[RAW])) { echo "<a href=\"message.php?mode=RAW\">Raw</a>&nbsp;&nbsp; "; } else { echo "Raw&nbsp;&nbsp; "; }
echo "<br>\n";
echo "<hr>\n";

// display the email header
if (($_SESSION[mode] == "PLAIN") || ($_SESSION[mode] == "HTML")) { 
  echo "Date: ".$header->date."<br>\n";
  echo "From: ".quoted_printable_decode(imap_utf8($header->from[0]->personal))." &lt;".$header->from[0]->mailbox . "@" . $header->from[0]->host."&gt; <br>\n";
  echo "To: ".quoted_printable_decode(imap_utf8($header->to[0]->personal))." &lt;".$header->to[0]->mailbox . "@" . $header->to[0]->host."&gt; <br>\n";
  echo "Subject: ".quoted_printable_decode(imap_utf8($header->subject))."<br>\n";
  echo "<br>\n";
}
else {
  echo "<pre>\n";
  foreach ($rawheaders as $rawheader) {
    echo $rawheader;
  }
  echo "</pre>\n";
}

// display the email body
if ($body[$_SESSION[mode]]) { echo $body[$_SESSION[mode]]; }
else { echo $body[RAW]; }


if ($debug) {
  echo "<pre>\n";
  print_r($parts);
  echo "</pre>\n";
}

echo "<hr>\n";

include_once "footer.php";

?>